#include <iostream>
#include "97a.h"

template<class T>
void A<T>::out1(T& val)
{
	std::cout << val << " (" << __FUNCTION__ << ")\n";
}

template<class T>
void A<T>::out2(T& val)
{
	std::cout << val << " (" << __FUNCTION__ << ")\n";
}

template<class T>
class Compiletime
{
public:
	void instantiate(T t)
	{
		A<T> at;
		at.out1(t);
		at.out2(t);
	}
};

struct _Init
{
	_Init() 
	{
		Compiletime<int>().instantiate(1);
#ifdef FOO
		Compiletime<unsigned>().instantiate(1);
#endif
	}
} Init;

int A<int>::val = 10;
#ifdef FOO
unsigned A<unsigned>::val = 20;
#endif